unit U_Dm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DB, DBTables, ADODB;


type
  TDm = class(TDataModule)
    Ds_Cli: TDataSource;
    Ds_Sistema: TDataSource;
    Ds_Usu: TDataSource;
    Ds_Prod: TDataSource;
    Ds_Forne: TDataSource;
    Ds_Parcela: TDataSource;
    Tb_Logon: TTable;
    Ds_Logon: TDataSource;
    Tb_LogonCodigo: TAutoIncField;
    Tb_LogonUsuario: TStringField;
    Tb_LogonData: TDateField;
    Tb_LogonHoraIni: TTimeField;
    Tb_LogonHoraFim: TTimeField;
    Tb_LogonTempo: TTimeField;
    Tb_LogonRec: TFloatField;
    Tb_LogonTotal: TFloatField;
    Ds_Compra: TDataSource;
    Ds_ItensCompra: TDataSource;
    Ds_CPagar: TDataSource;
    Database: TDatabase;
    NewCompra: TTable;
    NewCompraNew_Compra: TFloatField;
    Tb_Compra: TTable;
    Tb_CPagar: TTable;
    Tb_ItensCompra: TTable;
    Tb_CompraN_Compra: TFloatField;
    Tb_CompraN_Nota: TFloatField;
    Tb_CompraDt_Compra: TDateField;
    Tb_CompraDt_Devo: TDateField;
    Tb_CompraTip_Compra: TStringField;
    Tb_CompraCod_Pag: TStringField;
    Tb_CompraDescri_Pag: TStringField;
    Tb_CompraSub_Tot: TCurrencyField;
    Tb_CompraDesconto: TFloatField;
    Tb_CompraVal_Desc: TCurrencyField;
    Tb_CompraAcr: TFloatField;
    Tb_CompraVal_acr: TCurrencyField;
    Tb_CompraTot_Ger: TCurrencyField;
    Tb_CompraVal_Pag: TCurrencyField;
    Tb_CompraDebito: TCurrencyField;
    Tb_CompraNome_Forne: TStringField;
    Tb_CompraPagarem: TStringField;
    Tb_CompraN_Parcela: TStringField;
    Tb_CompraNome_Usu: TStringField;
    Tb_ItensCompraN_Itens: TFloatField;
    Tb_ItensCompraN_Compra: TFloatField;
    Tb_ItensCompraQty: TFloatField;
    Tb_CPagarN_Compra: TFloatField;
    Tb_CPagarParcela: TStringField;
    Tb_CPagarCod_Forne: TStringField;
    Tb_CPagarNome_Forne: TStringField;
    Tb_CPagarDt_Venc: TDateField;
    Tb_CPagarVal_Parce: TCurrencyField;
    Tb_CPagarDesconto: TFloatField;
    Tb_CPagarVal_Desconto: TCurrencyField;
    Tb_CPagarAcr: TFloatField;
    Tb_CPagarVal_Acr: TCurrencyField;
    Tb_CPagarVal_Pag: TCurrencyField;
    Tb_CPagarSituacao: TStringField;
    Tb_ItensCompraCod_Prod: TFloatField;
    Tb_ItensCompraVal_Unit: TCurrencyField;
    Tb_ItensCompraNome_Prod: TStringField;
    LastItensCompra: TQuery;
    Tb_ItensCompraDecricao: TStringField;
    Tb_ItensCompraVal_Prod: TCurrencyField;
    Tb_ItensCompraEdicao: TStringField;
    Tb_BContasPagar: TTable;
    Ds_BContasPagar: TDataSource;
    Tb_BContasPagarN_Compra: TFloatField;
    Tb_BContasPagarParcela: TStringField;
    Tb_BContasPagarFornecedor: TStringField;
    Tb_BContasPagarDt_Venc: TDateField;
    Tb_BContasPagarVal_Parc: TCurrencyField;
    Tb_BContasPagarDt_Pag: TDateField;
    Tb_BContasPagarTip_Pag: TStringField;
    Tb_BContasPagarDesconto: TFloatField;
    Tb_BContasPagarVal_Desc: TCurrencyField;
    Tb_BContasPagarAcrescimo: TFloatField;
    Tb_BContasPagarVal_Acrescimo: TCurrencyField;
    Tb_BContasPagarVal_Pag: TCurrencyField;
    Tb_BContasPagarSituacao: TStringField;
    Tb_Usu: TTable;
    Tb_UsuNome_Usu: TStringField;
    Tb_UsuSenha: TStringField;
    Tb_UsuConfirmarSenha: TStringField;
    Tb_UsuNome: TStringField;
    Tb_UsuTipo_Conta: TStringField;
    Tb_Prod: TQuery;
    Tb_ProdCod_Barra: TFloatField;
    Tb_ProdDescricao: TStringField;
    Tb_ProdEdicao: TStringField;
    Tb_ProdEditora: TStringField;
    Tb_ProdGrupo: TStringField;
    Tb_ProdNome_Forne: TStringField;
    Tb_ProdUnid: TStringField;
    Tb_ProdVal_Custo: TCurrencyField;
    Tb_ProdIcms: TFloatField;
    Tb_ProdValIcms: TCurrencyField;
    Tb_ProdIss: TFloatField;
    Tb_ProdVal_Iss: TCurrencyField;
    Tb_ProdIpi: TFloatField;
    Tb_ProdVal_Ipi: TCurrencyField;
    Tb_ProdOutros: TFloatField;
    Tb_ProdVal_Outros: TCurrencyField;
    Tb_ProdDesconto: TFloatField;
    Tb_ProdVal_Desconto: TCurrencyField;
    Tb_ProdMargem_lucro: TFloatField;
    Tb_ProdVal_MargemLucro: TCurrencyField;
    Tb_ProdVal_Venda: TCurrencyField;
    Tb_ProdQuanho_Real: TCurrencyField;
    Tb_ProdQty_Estoque: TFloatField;
    Tb_ProdQty_Min: TFloatField;
    Tb_ProdDt_Devol: TDateField;
    Tb_ProdUltimo_Valor: TCurrencyField;
    Tb_ProdPorcenta_vend: TFloatField;
    Tb_ProdObs: TMemoField;
    Tb_ProdDt_Devolu: TDateField;
    UpdateSQL1: TUpdateSQL;
    Tb_ItensCompraDt_Devo: TDateField;
    Tb_CPagarDt_pag: TDateField;
    Tb_CPagarTip_pag: TStringField;
    Tb_BContasPagarCod_Forn: TStringField;
    Tb_CPagarDevolucao: TCurrencyField;
    Tb_BContasPagarDevolucao: TCurrencyField;
    Tb_Venda: TTable;
    Tb_CReceber: TTable;
    Tb_ItensVenda: TTable;
    Tb_BContasReceber: TTable;
    Ds_Venda: TDataSource;
    Ds_CReceber: TDataSource;
    Ds_ItensVenda: TDataSource;
    DS_BContasReceber: TDataSource;
    Tb_VendaN_Venda: TFloatField;
    Tb_VendaN_Nota: TFloatField;
    Tb_VendaDt_Venda: TDateField;
    Tb_VendaTip_venda: TStringField;
    Tb_VendaCliente: TStringField;
    Tb_VendaVendedor: TStringField;
    Tb_VendaPag_em: TStringField;
    Tb_VendaESpecificacao: TStringField;
    Tb_VendaSituacao: TStringField;
    Tb_VendaCod_Pag: TStringField;
    Tb_VendaDescri_Pag: TStringField;
    Tb_VendaSub_Tot: TCurrencyField;
    Tb_VendaPreco_Custo: TCurrencyField;
    Tb_VendaDesconto: TFloatField;
    Tb_VendaVal_Desc: TCurrencyField;
    Tb_VendaAcr: TFloatField;
    Tb_VendaVal_Acr: TCurrencyField;
    Tb_VendaTot_Ger: TCurrencyField;
    Tb_VendaVal_Pag: TCurrencyField;
    Tb_VendaVal_Debito: TCurrencyField;
    Tb_CReceberN_Venda: TFloatField;
    Tb_CReceberParcela: TStringField;
    Tb_CReceberDt_Venc: TDateField;
    Tb_CReceberDt_pag: TDateField;
    Tb_CReceberTip_pag: TStringField;
    Tb_CReceberVal_Parce: TCurrencyField;
    Tb_CReceberDesconto: TFloatField;
    Tb_CReceberVal_Desconto: TCurrencyField;
    Tb_CReceberAcr: TFloatField;
    Tb_CReceberVal_Acr: TCurrencyField;
    Tb_CReceberVal_Pag: TCurrencyField;
    Tb_CReceberSituacao: TStringField;
    Tb_CReceberCod_Forne: TStringField;
    Tb_CReceberDevolucao: TCurrencyField;
    Tb_ItensVendaN_Itens: TFloatField;
    Tb_ItensVendaFornecedor: TStringField;
    Tb_ItensVendaDt_Venda: TDateField;
    Tb_ItensVendaCod_Prod: TFloatField;
    Tb_ItensVendaDescricao: TStringField;
    Tb_ItensVendaEdicao: TStringField;
    Tb_ItensVendaVal_prod: TCurrencyField;
    Tb_ItensVendaQty: TFloatField;
    Tb_BContasReceberN_Venda: TFloatField;
    Tb_BContasReceberParcela: TStringField;
    Tb_BContasReceberDt_Venc: TDateField;
    Tb_BContasReceberVal_Parc: TCurrencyField;
    Tb_BContasReceberDt_Pag: TDateField;
    Tb_BContasReceberTip_Pag: TStringField;
    Tb_BContasReceberDesconto: TFloatField;
    Tb_BContasReceberVal_Desc: TCurrencyField;
    Tb_BContasReceberAcrescimo: TFloatField;
    Tb_BContasReceberVal_Acrescimo: TCurrencyField;
    Tb_BContasReceberDevolucao: TCurrencyField;
    Tb_BContasReceberVal_Pag: TCurrencyField;
    Tb_BContasReceberSituacao: TStringField;
    Tb_ItensVendaN_Venda: TFloatField;
    NewVenda: TTable;
    NewVendaNew_Venda: TFloatField;
    Ds_Funci: TDataSource;
    Tb_ItensVendaNome_Prod: TStringField;
    Tb_ItensCompraVal_Compra: TCurrencyField;
    Tb_ItensVendaVal_venda: TCurrencyField;
    Tb_ItensVendaEdicaos: TStringField;
    Tb_BContasReceberFuncionario: TStringField;
    Tb_BContasReceberCliente: TStringField;
    Tb_VendaRecebido: TCurrencyField;
    Tb_VendaTroco: TCurrencyField;
    Tb_ItensVendaValor_unitario: TCurrencyField;
    LastItensVenda: TQuery;
    Tb_VendaOperador: TStringField;
    Tb_BContasReceberFornecedor: TStringField;
    Tb_ItensVendaNome_Forne: TStringField;
    Tb_VendaN_Pacelas: TStringField;
    Tb_CReceberNome_Cli: TStringField;
    Tb_CompraSITUACAO: TStringField;
    Ds_Recibo: TDataSource;
    Tb_Devolucao: TTable;
    Ds_Devolucao: TDataSource;
    Tb_ItensDevolucao: TTable;
    Ds_ItensDevolucao: TDataSource;
    Tb_DevolucaoN_Devolu: TFloatField;
    Tb_DevolucaoN_Nota: TFloatField;
    Tb_DevolucaoDt_Compra: TDateField;
    Tb_DevolucaoDt_Devolu: TDateField;
    Tb_DevolucaoFornecedor: TStringField;
    Tb_DevolucaoTot_Devolu: TCurrencyField;
    Tb_ItensDevolucaoN_Itens: TFloatField;
    Tb_ItensDevolucaoN_Devolu: TFloatField;
    Tb_ItensDevolucaoDt_Devolu: TDateField;
    Tb_ItensDevolucaoCod_prod: TFloatField;
    Tb_ItensDevolucaoDescricao: TStringField;
    Tb_ItensDevolucaoVal_Prod: TCurrencyField;
    Tb_ItensDevolucaoQty: TFloatField;
    Tb_ItensCompraFornecedor: TStringField;
    Tb_ItensDevolucaoVal_Devolu: TCurrencyField;
    Tb_ItensDevolucaoFornecedor: TStringField;
    Tb_ItensDevolucaoNome_Prod: TStringField;
    Tb_ItensDevolucaoVal_Unit: TCurrencyField;
    Tb_ItensDevolucaoNome_Forne: TStringField;
    Tb_ItensDevolucaoEdicao: TStringField;
    Tb_DevolucaoDesconto: TFloatField;
    Tb_DevolucaoVal_desc: TCurrencyField;
    Tb_DevolucaoAcr: TFloatField;
    Tb_DevolucaoVal_Acr: TCurrencyField;
    Tb_DevolucaoTot_ger: TCurrencyField;
    Tb_DevolucaoVal_Pag: TCurrencyField;
    Tb_DevolucaoDebito: TCurrencyField;
    Tb_DevolucaoPagoem: TStringField;
    Tb_DevolucaoSituacao: TStringField;
    Tb_ItensDevolucaoEdicaos: TStringField;
    LastItensDevolu: TQuery;
    NewDevolu: TTable;
    NewDevoluNew_Compra: TFloatField;
    Tb_DevolucaoUsuario: TStringField;
    Tb_ItensCompraNome_Forne: TStringField;
    Tb_CReceberFuncionario: TStringField;
    Tb_ProdTotalBu: TCurrencyField;
    Ds_Movimento: TDataSource;
    Ds_CDiversas: TDataSource;
    Ds_CDiversasPagar: TDataSource;
    Tb_Movimento: TTable;
    Tb_CDiversas: TTable;
    Tb_CDiversaPagar: TTable;
    Tb_MovimentoID_Registro: TAutoIncField;
    Tb_MovimentoN_Documento: TFloatField;
    Tb_MovimentoDt_Movimento: TDateField;
    Tb_MovimentoTip_Movimento: TStringField;
    Tb_MovimentoDescrio: TStringField;
    Tb_MovimentoValor_Lanamento: TCurrencyField;
    Tb_MovimentoValor_pag: TCurrencyField;
    Tb_MovimentoDebito: TCurrencyField;
    Tb_MovimentoSituao: TStringField;
    Tb_BDiversas: TTable;
    Ds_BDiversas: TDataSource;
    Tb_BDiversasDt_Pag: TDateField;
    Tb_BDiversasDt_Venc: TDateField;
    Tb_BDiversasParcela: TStringField;
    Tb_BDiversasDescricao: TStringField;
    Tb_BDiversasEspecifica: TStringField;
    Tb_BDiversasVal_Debi: TCurrencyField;
    Tb_BDiversasTitulo: TStringField;
    Tb_BDiversasVal_Pag: TCurrencyField;
    Tb_BDiversasTip_Pag: TStringField;
    Tb_BDiversasDesconto: TFloatField;
    Tb_BDiversasVal_Desc: TCurrencyField;
    Tb_BDiversasAcr: TFloatField;
    Tb_BDiversasVal_Acr: TCurrencyField;
    Tb_BDiversasSituacao: TStringField;
    Tb_MovimentoParcela: TStringField;
    Tb_MovimentoDt_Venc: TDateField;
    Tb_BDiversasId_Mov: TFloatField;
    Tb_CDiversaPagarId_Mov: TFloatField;
    Tb_CDiversaPagarParcelas: TStringField;
    Tb_CDiversaPagarDat_cad_: TDateField;
    Tb_CDiversaPagarDt_Pag: TDateField;
    Tb_CDiversaPagarDt_Venc: TDateField;
    Tb_CDiversaPagarDescricao: TStringField;
    Tb_CDiversaPagarEspecifica: TStringField;
    Tb_CDiversaPagarVal_Debi: TCurrencyField;
    Tb_CDiversaPagarVal_Pag: TCurrencyField;
    Tb_CDiversaPagarTip_Pag: TStringField;
    Tb_CDiversaPagarDesconto: TFloatField;
    Tb_CDiversaPagarVal_Desc: TCurrencyField;
    Tb_CDiversaPagarAcr: TFloatField;
    Tb_CDiversaPagarVal_Acr: TCurrencyField;
    Tb_CDiversaPagarSituacao: TStringField;
    Tb_CDiversasId_Mov: TFloatField;
    Tb_CDiversasParcela: TStringField;
    Tb_CDiversasTip_Movimento: TStringField;
    Tb_CDiversasDat_Cad: TDateField;
    Tb_CDiversasDat_Venc: TDateField;
    Tb_CDiversasDt_Pag: TDateField;
    Tb_CDiversasVal_Mov: TCurrencyField;
    Tb_CDiversasDesconto: TFloatField;
    Tb_CDiversasVal_Desc: TCurrencyField;
    Tb_CDiversasAcr: TFloatField;
    Tb_CDiversasVal_acr: TCurrencyField;
    Tb_CDiversasTot_Ger: TCurrencyField;
    Tb_CDiversasVal_Pag: TCurrencyField;
    Tb_CDiversasDebito: TCurrencyField;
    Tb_CDiversasPagoem: TStringField;
    Tb_CDiversasCondicao: TStringField;
    Tb_CDiversasSituacao: TStringField;
    Tb_BDiversasVal_Parce: TCurrencyField;
    Tb_CDiversaPagarVal_Parce: TCurrencyField;
    Tb_CDiversasCod_pag: TStringField;
    Tb_CDiversasDescr_Parcela: TStringField;
    Tb_CDiversaPagarTip_Movimento: TStringField;
    Tb_CDiversasDescricao: TStringField;
    Tb_ProdLocalizacao: TStringField;
    Tb_ItensVendaTotal: TCurrencyField;
    Tb_ProdTotal_estoque: TCurrencyField;
    Tb_ProdVendido: TStringField;
    Rel_Cli: TTable;
    Ds_rel_cli: TDataSource;
    Rel_CliQt: TAutoIncField;
    Rel_CliCod_Cli: TStringField;
    Rel_CliNome_Cli: TStringField;
    Rel_CliEnd_Cli: TStringField;
    Rel_CliBairro: TStringField;
    Rel_CliCidade: TStringField;
    Rel_CliUf: TStringField;
    Rel_CliCep: TStringField;
    Rel_CliFone: TStringField;
    Rel_CliCel: TStringField;
    Rel_CliDt_niver: TDateField;
    Rel_CliDt_ini: TDateField;
    Rel_CliDt_Fim: TDateField;
    Rel_CliEmail: TStringField;
    Rel_Func: TTable;
    Ds_Rel_func: TDataSource;
    Rel_FuncQt: TAutoIncField;
    Rel_FuncCod_Cli: TStringField;
    Rel_FuncNome_Cli: TStringField;
    Rel_FuncEnd_Cli: TStringField;
    Rel_FuncBairro: TStringField;
    Rel_FuncCidade: TStringField;
    Rel_FuncUf: TStringField;
    Rel_FuncCep: TStringField;
    Rel_FuncFone: TStringField;
    Rel_FuncCel: TStringField;
    Rel_FuncEmail: TStringField;
    Rel_FuncAtivo: TStringField;
    Rel_FuncDt_niver: TDateField;
    Rel_FuncDt_ini: TDateField;
    Rel_FuncDt_Fim: TDateField;
    Ds_RelForne: TDataSource;
    Rel_Forne: TTable;
    Rel_ForneQt: TAutoIncField;
    Rel_ForneCod_Forne: TStringField;
    Rel_ForneRazaoSocial: TStringField;
    Rel_ForneNomeFantasia: TStringField;
    Rel_ForneEnde: TStringField;
    Rel_ForneBairro: TStringField;
    Rel_ForneCidade: TStringField;
    Rel_ForneUf: TStringField;
    Rel_ForneCep: TStringField;
    Rel_ForneFone: TStringField;
    Rel_ForneFax: TStringField;
    Rel_ForneCel: TStringField;
    Rel_ForneContato: TStringField;
    Rel_ForneFuncao: TStringField;
    Rel_ForneCnpj: TStringField;
    Rel_ForneI_estadual: TStringField;
    Rel_ForneCpf: TStringField;
    Rel_ForneRg: TStringField;
    Rel_ForneNiver_Contato: TDateField;
    Rel_ForneNiver_forne: TDateField;
    Rel_ForneDt_Cad: TDateField;
    Rel_ForneObs: TMemoField;
    Rel_ForneTipo_Forne: TStringField;
    Tb_ProdTotalVenda: TCurrencyField;
    Tb_ItensCompraDt_Compra: TDateField;
    Tb_ItensCompraTotal: TCurrencyField;
    Historico: TTable;
    Ds_Historico: TDataSource;
    HistoricoID_Registro: TAutoIncField;
    HistoricoN_Documento: TFloatField;
    HistoricoParcela: TStringField;
    HistoricoDt_Movimento: TDateField;
    HistoricoDt_Venc: TDateField;
    HistoricoTip_Movimento: TStringField;
    HistoricoDescrio: TStringField;
    HistoricoValor_Lanamento: TCurrencyField;
    HistoricoValor_pag: TCurrencyField;
    HistoricoDebito: TCurrencyField;
    HistoricoSituao: TStringField;
    HistoricoDt_Ini: TDateField;
    HistoricoDt_fim: TDateField;
    Tb_LogonAcao: TStringField;
    Niver_Cli: TTable;
    Niver_Func: TTable;
    Ds_NiverCli: TDataSource;
    Ds_NiverFunc: TDataSource;
    Niver_CliNome: TStringField;
    Niver_CliDia: TStringField;
    Niver_CliEnd: TStringField;
    Niver_CliBairro: TStringField;
    Niver_CliCep: TStringField;
    Niver_CliCidade: TStringField;
    Niver_CliUf: TStringField;
    Niver_CliFone: TStringField;
    Niver_CliMes: TStringField;
    Niver_FuncNome: TStringField;
    Niver_FuncDia: TStringField;
    Niver_FuncSetor: TStringField;
    Niver_FuncFuncao: TStringField;
    Niver_FuncFone: TStringField;
    Niver_FuncMes: TStringField;
    Tb_ProdVal_Porcenta: TCurrencyField;
    Tb_ItensVendaVal_Comi: TCurrencyField;
    Tb_ItensVendaTot_Comi: TCurrencyField;
    Tb_VendaComi_Vend: TCurrencyField;
    Tb_ItensVendaVendedor: TStringField;
    Tb_CDiversasFavorecido: TStringField;
    Tb_VendaTip_Mov: TStringField;
    Tb_VendaDescr_Mov: TStringField;
    Tb_VendaEntrega: TStringField;
    Tb_VendaPrev_entrega: TDateField;
    Tb_VendaDt_envio: TDateField;
    Tb_VendaDt_entrega: TDateField;
    Tb_VendaDt_Devolucao: TDateField;
    Tb_VendaD_Atraso: TFloatField;
    Ds_Grupo: TDataSource;
    Ds_Local: TDataSource;
    Rel_FuncFoto: TBlobField;
    Rel_CliFoto: TBlobField;
    Tb_ProdTransporte: TCurrencyField;
    Tb_ProdPreco_Custo: TCurrencyField;
    Tb_ProdDt_Cad: TDateField;
    Tb_ProdCod_Fab: TStringField;
    Tb_VendaOperadora: TStringField;
    Tb_ItensVendaTip_pag: TStringField;
    Tb_ItensVendaOperadora: TStringField;
    Tb_ItensVendaPercent_Desc: TFloatField;
    Tb_ItensVendaVal_Desconto: TCurrencyField;
    Tb_Cliente: TQuery;
    Tb_ClienteCod_Cli: TStringField;
    Tb_ClienteNome_Cli: TStringField;
    Tb_ClienteEnd_cli: TStringField;
    Tb_ClienteBairro: TStringField;
    Tb_ClienteCidade: TStringField;
    Tb_ClienteUf: TStringField;
    Tb_ClienteDt_Cad: TDateField;
    Tb_ClienteDt_Niver: TDateField;
    Tb_ClienteFone: TStringField;
    Tb_ClienteFone_cont: TStringField;
    Tb_ClienteCel: TStringField;
    Tb_ClienteRg: TStringField;
    Tb_ClienteCpf: TStringField;
    Tb_ClienteCep: TStringField;
    Tb_ClienteSexo: TStringField;
    Tb_ClienteEmail: TStringField;
    Tb_ClienteFoto: TBlobField;
    Tb_ClienteObs: TMemoField;
    Tb_Forne: TQuery;
    Tb_ForneCod_Forne: TStringField;
    Tb_ForneRazaoSocial: TStringField;
    Tb_ForneNomeFantasia: TStringField;
    Tb_ForneEnde: TStringField;
    Tb_ForneBairro: TStringField;
    Tb_ForneCidade: TStringField;
    Tb_ForneUf: TStringField;
    Tb_ForneCep: TStringField;
    Tb_ForneFone: TStringField;
    Tb_ForneFax: TStringField;
    Tb_ForneCel: TStringField;
    Tb_ForneContato: TStringField;
    Tb_ForneFuncao: TStringField;
    Tb_ForneCnpj: TStringField;
    Tb_ForneI_estadual: TStringField;
    Tb_ForneCpf: TStringField;
    Tb_ForneRg: TStringField;
    Tb_ForneNiver_Contato: TDateField;
    Tb_ForneNiver_forne: TDateField;
    Tb_ForneDt_Cad: TDateField;
    Tb_ForneObs: TMemoField;
    Tb_ForneTipo_Forne: TStringField;
    Tb_Parcela: TQuery;
    Tb_ParcelaCod_Pag: TStringField;
    Tb_ParcelaDescricao: TStringField;
    Tb_ParcelaParcelas: TStringField;
    Tb_Funci: TQuery;
    Tb_FunciCod_Funci: TStringField;
    Tb_FunciNome: TStringField;
    Tb_FunciEnd: TStringField;
    Tb_FunciBairro: TStringField;
    Tb_FunciCep: TStringField;
    Tb_FunciCidade: TStringField;
    Tb_FunciUf: TStringField;
    Tb_FunciTel: TStringField;
    Tb_FunciTel_contato: TStringField;
    Tb_FunciCel: TStringField;
    Tb_FunciRg: TStringField;
    Tb_FunciCpf: TStringField;
    Tb_FunciAtivo: TStringField;
    Tb_FunciDt_Cad: TDateField;
    Tb_FunciDt_NIver: TDateField;
    Tb_FunciSexo: TStringField;
    Tb_FunciEmail: TStringField;
    Tb_FunciFoto: TBlobField;
    Tb_Sistema: TQuery;
    Tb_SistemaEmpresa: TStringField;
    Tb_SistemaResponsavel: TStringField;
    Tb_SistemaSlogan: TStringField;
    Tb_SistemaEnd: TStringField;
    Tb_SistemaBairro: TStringField;
    Tb_SistemaCidade: TStringField;
    Tb_SistemaUf: TStringField;
    Tb_SistemaCep: TStringField;
    Tb_SistemaFone: TStringField;
    Tb_SistemaFax: TStringField;
    Tb_SistemaCel: TStringField;
    Tb_SistemaCnpj: TStringField;
    Tb_SistemaI_estadual: TStringField;
    Tb_SistemaInstal: TDateField;
    Tb_SistemaPeriodo: TFloatField;
    Tb_SistemaTrava: TStringField;
    Tb_SistemaLogo: TBlobField;
    Tb_Grupo: TQuery;
    Tb_GrupoCod_Grupo: TFloatField;
    Tb_GrupoDescri_Grupo: TStringField;
    Tb_Local: TQuery;
    Tb_LocalCod_Localiza: TFloatField;
    Tb_LocalDescricao: TStringField;
    Tb_Recibo: TQuery;
    Tb_ReciboRecibo_N: TFloatField;
    Tb_ReciboValor: TCurrencyField;
    Tb_ReciboDt_emicao: TDateField;
    Tb_ReciboVias: TFloatField;
    Tb_ReciboRecebi: TStringField;
    Tb_ReciboNome_Recebi: TStringField;
    Tb_ReciboCpf_Recebi: TStringField;
    Tb_ReciboRg_Recebi: TStringField;
    Tb_ReciboReferente: TStringField;
    Tb_ReciboEmitente: TStringField;
    Tb_ReciboNome_Emitente: TStringField;
    Tb_ReciboCpf_Emitente: TStringField;
    Tb_ReciboRg_Emitente: TStringField;
    Tb_ReciboEnd_emitente: TStringField;
    Tb_ReciboObs: TStringField;
    Tb_ReciboAno1: TDateField;
    Tb_ReciboAno: TFloatField;
    Tb_ItensCompraCod_Fab: TStringField;
    Tb_ItensVendaHora_ini: TTimeField;
    Tb_ItensVendaHora_Fim: TTimeField;
    Tb_VendaHora_venda: TTimeField;
    Tb_ItensCompraCod_Fa: TStringField;
    Tb_ItensVendaTipo_venda: TStringField;
    Tb_ItensVendaV_Desc: TCurrencyField;
    Tb_ItensVendaQty_Min: TIntegerField;
    procedure EnsureVendaEdit(DataSet: TDataSet);
    procedure EnsureCompraEdit(DataSet: TDataSet);
    procedure EnsureDevolucaoEdit(DataSet: TDataSet);    
    procedure Tb_ClienteNewRecord(DataSet: TDataSet);
    procedure Tb_ForneNewRecord(DataSet: TDataSet);
    procedure Tb_LogonCalcFields(DataSet: TDataSet);
    procedure Tb_CompraAfterDelete(DataSet: TDataSet);
    procedure Tb_CompraAfterPost(DataSet: TDataSet);
    procedure Tb_CompraBeforeCancel(DataSet: TDataSet);
    procedure Tb_CompraBeforeClose(DataSet: TDataSet);
    procedure Tb_CompraBeforeDelete(DataSet: TDataSet);
    procedure Tb_CompraBeforeEdit(DataSet: TDataSet);
    procedure Tb_CompraBeforeInsert(DataSet: TDataSet);
    procedure Tb_CompraBeforeOpen(DataSet: TDataSet);
    procedure Tb_CompraNewRecord(DataSet: TDataSet);
    procedure Tb_ItensCompraAfterDelete(DataSet: TDataSet);
    procedure Tb_ItensCompraAfterPost(DataSet: TDataSet);
    procedure Tb_ItensCompraBeforeDelete(DataSet: TDataSet);
    procedure Tb_ItensCompraBeforeEdit(DataSet: TDataSet);
    procedure Tb_ItensCompraBeforeOpen(DataSet: TDataSet);
    procedure Tb_ItensCompraBeforePost(DataSet: TDataSet);
    procedure Tb_ItensCompraCalcFields(DataSet: TDataSet);
    procedure Tb_ItensCompraNewRecord(DataSet: TDataSet);
    procedure Tb_CompraUpdateError(DataSet: TDataSet; E: EDatabaseError;
      UpdateKind: TUpdateKind; var UpdateAction: TUpdateAction);
    procedure Tb_CompraDt_CompraValidate(Sender: TField);
    procedure Tb_ItensCompraCod_ProdValidate(Sender: TField);
    procedure Tb_CompraTot_gerValidate(Sender: TField);
    procedure Tb_ProdNewRecord(DataSet: TDataSet);
    procedure Tb_VendaAfterDelete(DataSet: TDataSet);
    procedure Tb_VendaAfterPost(DataSet: TDataSet);
    procedure Tb_VendaBeforeDelete(DataSet: TDataSet);
    procedure Tb_VendaBeforeEdit(DataSet: TDataSet);
    procedure Tb_VendaBeforeInsert(DataSet: TDataSet);
    procedure Tb_VendaBeforeOpen(DataSet: TDataSet);
    procedure Tb_VendaNewRecord(DataSet: TDataSet);
    procedure Tb_ItensVendaAfterDelete(DataSet: TDataSet);
    procedure Tb_ItensVendaAfterPost(DataSet: TDataSet);
    procedure Tb_ItensVendaBeforeDelete(DataSet: TDataSet);
    procedure Tb_ItensVendaBeforeEdit(DataSet: TDataSet);
    procedure Tb_ItensVendaBeforeOpen(DataSet: TDataSet);
    procedure Tb_ItensVendaBeforePost(DataSet: TDataSet);
    procedure Tb_ItensVendaNewRecord(DataSet: TDataSet);
    procedure Tb_ItensVendaCalcFields(DataSet: TDataSet);
    procedure Tb_DevolucaoAfterPost(DataSet: TDataSet);
    procedure Tb_DevolucaoBeforeDelete(DataSet: TDataSet);
    procedure Tb_DevolucaoBeforeEdit(DataSet: TDataSet);
    procedure Tb_DevolucaoBeforeInsert(DataSet: TDataSet);
    procedure Tb_DevolucaoBeforeOpen(DataSet: TDataSet);
    procedure Tb_DevolucaoNewRecord(DataSet: TDataSet);
    procedure Tb_ItensDevolucaoAfterDelete(DataSet: TDataSet);
    procedure Tb_ItensDevolucaoAfterPost(DataSet: TDataSet);
    procedure Tb_ItensDevolucaoBeforeDelete(DataSet: TDataSet);
    procedure Tb_ItensDevolucaoBeforeEdit(DataSet: TDataSet);
    procedure Tb_ItensDevolucaoBeforePost(DataSet: TDataSet);
    procedure Tb_ItensDevolucaoNewRecord(DataSet: TDataSet);
    procedure Tb_ItensDevolucaoCalcFields(DataSet: TDataSet);
    procedure Tb_ItensVendaQtyValidate(Sender: TField);
    procedure Tb_ItensVendaCod_ProdValidate(Sender: TField);
    procedure Tb_ItensCompraQtyValidate(Sender: TField);
    procedure Tb_VendaDt_VendaValidate(Sender: TField);
    procedure Tb_ItensDevolucaoQtyValidate(Sender: TField);
    procedure Tb_ItensDevolucaoCod_prodValidate(Sender: TField);
    procedure Tb_CDiversasNewRecord(DataSet: TDataSet);
    procedure Tb_VendaBeforeClose(DataSet: TDataSet);
    procedure Tb_VendaBeforeCancel(DataSet: TDataSet);
  private
    PrevPartNC: Double;
    PrevQtyC: Double;
    DeletingItemsC: Boolean;
    FItemNC: Integer;
    PrevPart: Double;
    PrevQty: Double;
    DeletingItems: Boolean;
    FItem: Integer;
    PrevPartD: Double;
    PrevQtyD: Double;
    DeletingItemsD: Boolean;
    FItemD: Integer;


    function DataDirectory: string;
    procedure SetDatabaseAlias(AliasName: string);
    procedure UpdateTotalsDevolu;
    procedure UpdateTotalsCompra;
    Procedure UpdateTotals;
  public
    { Public declarations }
    procedure DeleteItemsCompras;
    procedure DeleteItemsVenda;
    procedure DeleteItemsDevolu;
    procedure UseLocalData;
    procedure UseRemoteData;
    function DataSetApplyUpdates(DataSet: TDataSet; Apply: Boolean): Boolean;
    function Confirm(Msg: string): Boolean;
  end;


var
  Dm: TDm;

implementation

{$R *.dfm}
Uses Variants, U_Principal, U_Venda;



procedure TDm.Tb_ClienteNewRecord(DataSet: TDataSet);
begin
Dm.Tb_ClienteDt_Cad.Value:=Date;
end;

procedure TDm.Tb_ForneNewRecord(DataSet: TDataSet);
begin
Dm.Tb_ForneDt_Cad.Value:=Date;
Dm.Tb_ForneTipo_Forne.Value:='JURIDICO';
end;

procedure TDm.Tb_LogonCalcFields(DataSet: TDataSet);
begin
Dm.Tb_LogonRec.Value:= Dm.Tb_logon.RecNo;
Dm.Tb_LogonTotal.Value:= Dm.Tb_Logon.RecordCount;
end;

procedure TDm.Tb_CompraAfterDelete(DataSet: TDataSet);
begin
//  Database.ApplyUpdates([Tb_ItensCompra, Tb_Compra]);
end;

procedure TDm.Tb_CompraAfterPost(DataSet: TDataSet);
begin
if Dm.Tb_ItensCompra.Locate('N_Compra', Dm.Tb_ItensCompraN_Compra.Value, []) Then
  begin
    Dm.Tb_ItensCompra.Edit;
    Dm.Tb_ItensCompra.Post;
end;
 end;

procedure TDm.Tb_CompraBeforeCancel(DataSet: TDataSet);
begin
if (Dm.Tb_Compra.State = dsInsert) and not (Dm.Tb_ItensCompra.BOF and Dm.Tb_ItensCompra.EOF and Dm.Tb_CPagar.EOF) then
    if not Confirm('Cancelar inclusso de Compra e seus respectivos'#13'itens e parcelamentos?') then
      Abort;

end;

function TDm.Confirm(Msg: string): Boolean;
begin
  Result := MessageDlg(Msg, mtConfirmation, mbYesNoCancel, 0) = mrYes;
end;

procedure TDm.Tb_CompraBeforeClose(DataSet: TDataSet);
begin
 Tb_ItensCompra.Close;
end;

procedure TDm.Tb_CompraBeforeDelete(DataSet: TDataSet);
begin
if not Confirm('Excluir entrada em estoque e todos os seus respectivos'#13'itens e parcelamentos?') then
    Abort
  else
    DeleteItemsCompras;
end;

procedure TDm.Tb_CompraBeforeEdit(DataSet: TDataSet);
begin
  LastItensCompra.Close;
  LastItensCompra.Open;
  with LastItensCompra.Fields[0] do
    if IsNull then FItemNC := 1
    else
    FItemNC := AsInteger + 1;
end;

procedure TDm.Tb_CompraBeforeInsert(DataSet: TDataSet);
begin
  if Tb_Compra.State in dsEditModes then
  begin
    if Confirm('Uma entrada em estoque est sendo processada. Deseja Grava-la e abrir outra entrada?') then
      Tb_Compra.Post
    else
      Abort;
  end;
  FItemNC := 1;
end;

procedure TDm.Tb_CompraBeforeOpen(DataSet: TDataSet);
begin
Dm.Tb_ItensCompra.Open;
end;

procedure TDm.Tb_CompraNewRecord(DataSet: TDataSet);
begin
 with NewCompra do
  begin
    Open;
    try
      Edit;
      Dm.Tb_CompraN_Compra.Value := Dm.NewCompraNew_Compra.Value;
      Dm.NewCompraNew_Compra.Value := Dm.NewCompraNew_Compra.Value + 1;
      Post;
    finally
    close;
    end;
    end; 
  Dm.Tb_CompraNome_Usu.Value:=Dm.Tb_UsuNome.Value;
  Dm.Tb_CompraDt_Compra.Value := Date;
  Dm.Tb_CompraSub_Tot.Value:=0;
  Dm.Tb_CompraDesconto.Value:=0;
  Dm.Tb_CompraVal_Desc.Value:=0;
  Dm.Tb_CompraAcr.Value:=0;
  Dm.Tb_CompraVal_Acr.Value:=0;
  Dm.Tb_CompraTot_Ger.Value:=0;
  Dm.Tb_CompraVal_Pag.Value:=0;
  Dm.Tb_CompraDebito.Value:=0;
end;

procedure TDm.Tb_ItensCompraAfterDelete(DataSet: TDataSet);
begin
  UpdateTotalsCompra;
end;

procedure TDm.Tb_ItensCompraAfterPost(DataSet: TDataSet);
procedure UpdateProdVenda(Cod_Prod: Double; Qty : Double);
  begin
    if (Cod_Prod > 0) and (Qty <> 0) then
    try
      if not Dm.Tb_Prod.Locate('Cod_Barra', Cod_Prod, []) then
      Abort;
      Dm.Tb_ItensCompra.Edit;
      Dm.Tb_ItensCompraDt_Compra.Value:= Dm.Tb_CompraDt_Compra.Value;
      Dm.Tb_ItensCompraDecricao.Value:=Dm.Tb_ItensCompraNome_Prod.Value;
      Dm.Tb_ItensCompraVal_Prod.Value:=Dm.Tb_ItensCompraVal_Unit.Value;
      Dm.Tb_ItensCompraTotal.Value:= Dm.Tb_ItensCompraVal_Unit.Value * Dm.Tb_ItensCompraQty.Value;
      Dm.Tb_ItensCompraFornecedor.Value:= Dm.Tb_ItensCompraNome_Forne.Value;
      Dm.Tb_ItensCompraCod_Fab.Value:= Dm.Tb_ItensCompraCod_Fa.Value;
      Dm.Tb_Prod.Edit;
      Dm.Tb_ProdQty_Estoque.Value := Dm.Tb_ProdQty_Estoque.Value + Qty;
      Dm.Tb_ProdQuanho_Real.Value:= Dm.Tb_ProdUltimo_Valor.Value * Dm.Tb_ProdQty_Estoque.Value;
      Dm.Tb_ProdTotal_estoque.Value:=Dm.Tb_ProdVal_Venda.Value * Dm.Tb_ProdQty_Estoque.Value;
      Dm.Tb_ProdEdicao.Value:=Dm.Tb_ItensCompraEdicao.Value;
      Dm.Tb_ProdDt_Devol.Value:= Dm.Tb_ItensCompraDt_Devo.Value;
      Dm.Tb_Prod.Post;
    except
      on E: Exception do
        ShowMessage(Format('Erro ao atualizar tabela de Produtos : %d', [Cod_Prod]));
    end;
  end;
begin
  Inc(FItemNC);
  UpdateTotalsCompra;
  if not ((PrevPartNC = Dm.Tb_ItensCompraCod_Prod.Value) and (PrevQtyC = Dm.Tb_ItensCompraQty.Value)) then
  begin
    UpdateProdVenda(PrevPartNC, + PrevQtyC);
    UpdateProdVenda(Dm.Tb_ItensCompraCod_Prod.Value, Dm.Tb_ItensCompraQty.Value);
  end;
end;

function TDm.DataDirectory: string;
begin
  Result := ExtractFilePath(ParamStr(0));
  Result := ExpandFileName(Result + '..\..\DATA\');
end;

procedure TDm.SetDatabaseAlias(AliasName: string);
begin
  Screen.Cursor := crHourGlass;
  try
    Database.Close;
    Database.AliasName := AliasName;
    Database.Open;
  finally
    Screen.Cursor := crDefault;
  end;
end;

procedure TDm.UpdateTotalsCompra;
var
  TempTotal2: Extended;
  PrevRecord2: TBookmark;
begin
  if DeletingItemsC then
  Exit;
  PrevRecord2 := Dm.Tb_ItensCompra.GetBookmark;
  try
    Dm.Tb_ItensCompra.DisableControls;
    Dm.Tb_ItensCompra.First;
    TempTotal2 := 0;
    while not Dm.Tb_ItensCompra.EOF do
    begin
      TempTotal2 := TempTotal2 + Dm.Tb_ItensCompraVal_Compra.Value;
      Dm.Tb_ItensCompra.Next;
    end;
    Dm.Tb_CompraSub_Tot.Value := TempTotal2;
  finally
     Dm.Tb_ItensCompra.EnableControls;
     if PrevRecord2 <> nil then
     begin
       Dm.Tb_ItensCompra.GotoBookmark(PrevRecord2);
       Dm.Tb_ItensCompra.FreeBookmark(PrevRecord2);
     end;
  end;
end;

procedure TDm.Tb_ItensCompraBeforeDelete(DataSet: TDataSet);
procedure UpdateProdVenda(Cod_Prod: Double; Qty : Double);
  begin
    if (Cod_Prod > 0) and (Qty <> 0) then
    try
      if not Dm.Tb_Prod.Locate('Cod_Barra', Cod_Prod, []) then
      Abort;
      Dm.Tb_Prod.Edit;
      Dm.Tb_ProdQty_Estoque.Value := Dm.Tb_ProdQty_Estoque.Value + Qty;
      Dm.Tb_ProdQuanho_Real.Value:= Dm.Tb_ProdUltimo_Valor.Value * Dm.Tb_ProdQty_Estoque.Value;
      Dm.Tb_ProdTotal_estoque.Value:=Dm.Tb_ProdVal_Venda.Value * Dm.Tb_ProdQty_Estoque.Value;
      Dm.Tb_Prod.Post;
    except
      on E: Exception do
        ShowMessage(Format('Erro ao atualizar tabela de Produtos : %d', [Cod_Prod]));
    end;
  end;
begin
  Inc(FItemNC);
  UpdateTotalsCompra;
  if not ((PrevPartNC = Dm.Tb_ItensCompraCod_Prod.Value) and (PrevQtyC = Dm.Tb_ItensCompraQty.Value)) then
  begin
    UpdateProdVenda(PrevPartNC, + PrevQtyC);
    UpdateProdVenda(Dm.Tb_ItensCompraCod_Prod.Value, Dm.Tb_ItensCompraQty.Value);
  end;
   end;

procedure TDm.Tb_ItensCompraBeforeEdit(DataSet: TDataSet);
begin
  Tb_Compra.Edit;
  PrevPartNC := Dm.Tb_ItensCompraCod_Prod.Value;
  PrevQtyC := Dm.Tb_ItensCompraQty.Value;
end;

procedure TDm.EnsureCompraEdit(DataSet: TDataSet);
begin
  Dm.Tb_Compra.Edit;
end;

procedure TDm.Tb_ItensCompraBeforeOpen(DataSet: TDataSet);
begin
Dm.Tb_Prod.open;
end;

procedure TDm.Tb_ItensCompraBeforePost(DataSet: TDataSet);
begin
  Dm.Tb_ItensCompraN_Itens.Value := FItemNC;
end;

procedure TDm.Tb_ItensCompraCalcFields(DataSet: TDataSet);
begin
Dm.Tb_ItensCompraVal_Compra.Value:= Dm.Tb_ItensCompraVal_Unit.Value*Dm.Tb_ItensCompraQty.Value;
end;

procedure TDm.Tb_ItensCompraNewRecord(DataSet: TDataSet);
begin
  PrevPartNC := 0;
  PrevQtyC := 0;
  Dm.Tb_ItensCompraN_Compra.Value := Dm.Tb_CompraN_Compra.Value;
end;

function TDm.DataSetApplyUpdates(DataSet: TDataSet;
  Apply: Boolean): Boolean;
begin
  Result := True;
  with TDBDataSet(DataSet) do
  begin
    if (State in dsEditModes) or UpdatesPending then
    begin
      if Apply then
      begin
        Database.ApplyUpdates([DataSet as TDBDataSet]);
        CancelUpdates;
      end
      else
      begin
        if (MessageDlg('No houve mudana,continuar assim mesmo?', mtConfirmation,
          [mbYes, mbCancel], 0) = mrYes) then
          CancelUpdates
        else
          Result := False;
      end;
    end;
  end;

end;

procedure TDm.DeleteItemsCompras;
begin
  DeletingItemsC := True;
  Dm.Tb_ItensCompra.DisableControls;
 try
    Dm.Tb_ItensCompra.First;
    Dm.Tb_Prod.Edit;
    while not Dm.Tb_ItensCompra.EOF do Dm.Tb_ItensCompra.Delete;
    While Not Dm.Tb_CPagar.Eof do Dm.Tb_CPagar.Delete;
//    While Not Dm.Tb_Movimento.Eof do Dm.Tb_Movimento.Delete;
  finally
    DeletingItemsC := False;
    Dm.Tb_Itenscompra.EnableControls;
  end;
end;

procedure TDm.UseLocalData;
var
  DataDir: string;
begin
  if not Session.IsAlias('Revista') then
  begin
    DataDir := DataDirectory;
    if not FileExists(DataDir+'Logon.DB') then
      raise Exception.Create('No foi possivel localizar arquivos de dados do Paradox');
    Session.AddStandardAlias('Revista', DataDir, 'PARADOX');
  end;
  SetDatabaseAlias('Revista');
end;

procedure TDm.UseRemoteData;
Var
  Params: TStringList;
  DataFile: string;
begin
  if not Session.IsAlias('SISBANCASQL') then
  begin
    DataFile := DataDirectory + 'SISBANCASQL.GDB';
    if not FileExists(DataFile) then
      raise Exception.Create('No foi possivel localizar arquivo de dados Interbase: VENDASQL.GDB');
    Params := TStringList.create;
    try
      Params.Values['SERVER NAME'] := DataFile;
      Params.Values['USER NAME'] := 'SYSDBA';
      Session.AddAlias('SISBANCASQL', 'INTRBASE', Params);
    finally
       Params.Free;
    end;
  end;
  SetDatabaseAlias('SISBANCASQL');
end;


procedure TDm.Tb_CompraUpdateError(DataSet: TDataSet; E: EDatabaseError;
  UpdateKind: TUpdateKind; var UpdateAction: TUpdateAction);
var
  Key: Variant;
const
  UpdErrMsg = '%s.'#13#10'Descartar ou editar a tabela %S %S e continuar atualizando?';
begin
  if UpdateKind = ukDelete then
    Key := Dataset.Fields[0].OldValue else
    Key := Dataset.Fields[0].NewValue;
  if MessageDlg(Format(UpdErrMsg, [E.Message, DataSet.Fields[0].DisplayLabel, Key]),
    mtConfirmation, [mbYes, mbCancel], 0) = mrYes then
    UpdateAction := uaSkip else
    UpdateAction := uaAbort;
end;

procedure TDm.Tb_CompraDt_CompraValidate(Sender: TField);
begin
  if Dm.Tb_CompraDt_Compra.Value > Now then
  raise Exception.Create('No e possivel efetuar compra para uma data futura');
end;

procedure TDm.Tb_ItensCompraCod_ProdValidate(Sender: TField);
begin
  if not Dm.Tb_Prod.Locate('Cod_Barra', Dm.Tb_ItensCompraCod_Prod.Value, []) then
   raise Exception.Create('Voc precisa especificar um codigo de barra vlido para o produto');
end;

procedure TDm.Tb_CompraTot_gerValidate(Sender: TField);
begin
  if Dm.Tb_CompraTot_Ger.Value < 0 then
  raise Exception.Create('Total do movimento no pode ser menor ou igual a zero');
end;

procedure TDm.Tb_ProdNewRecord(DataSet: TDataSet);
begin
Dm.Tb_ProdUnid.Value:='Un';
Dm.Tb_ProdIcms.Value:=0;
Dm.Tb_ProdValIcms.value:=0;
Dm.Tb_ProdIpi.Value:=0;
Dm.Tb_ProdVal_Ipi.Value:=0;
Dm.Tb_ProdIss.Value:=0;
Dm.Tb_ProdVal_Iss.Value:=0;
Dm.Tb_ProdOutros.Value:=0;
Dm.Tb_ProdVal_Outros.Value:=0;
Dm.Tb_ProdDesconto.Value:=0;
Dm.Tb_ProdVal_Desconto.Value:=0;
Dm.Tb_ProdMargem_lucro.Value:=0;
Dm.Tb_ProdVal_MargemLucro.Value:=0;
Dm.Tb_ProdVal_Venda.Value:=0;
Dm.Tb_ProdQty_Min.Value:=0;
Dm.Tb_ProdPorcenta_vend.Value:=0;
Dm.Tb_ProdDt_Cad.Value:= Date;
end;

procedure TDm.Tb_VendaAfterDelete(DataSet: TDataSet);
begin
//Dm.Tb_Venda.Delete;
end;

procedure TDm.Tb_VendaAfterPost(DataSet: TDataSet);
begin
if Dm.Tb_ItensVenda.Locate('N_Venda', Dm.Tb_ItensVendaN_Venda.Value, []) Then
  begin
    Dm.Tb_ItensVenda.Edit;
    Dm.Tb_ItensVenda.Post;
end;
 end;

procedure TDm.Tb_VendaBeforeDelete(DataSet: TDataSet);
begin
if not Confirm('Excluir venda e todos os seus respectivos'#13'itens e parcelamentos?') then
    Abort
  else
    DeleteItemsvenda;
end;

procedure TDm.Tb_VendaBeforeEdit(DataSet: TDataSet);
begin
  LastItensVenda.Close;
  LastItensVenda.Open;
  with LastItensVenda.Fields[0] do
    if IsNull then FItemNC := 1
    else
    FItemNC := AsInteger + 1;
end;

procedure TDm.Tb_VendaBeforeInsert(DataSet: TDataSet);
begin
  if Tb_Venda.State in dsEditModes then
  begin
    if Confirm('Uma venda est sendo processada. Deseja Grava-la e abrir outra venda?') then
      Tb_Venda.Post
    else
      Abort;
  end;
  FItemNC := 1;
end;

procedure TDm.Tb_VendaBeforeOpen(DataSet: TDataSet);
begin
Dm.Tb_ItensVenda.Open;
end;

procedure TDm.Tb_VendaNewRecord(DataSet: TDataSet);
begin
{ with NewVenda do
  begin
    Open;
    try
      Edit;
      Dm.Tb_VendaN_Venda.Value := Dm.NewVendaNew_Venda.Value;
      Dm.NewVendaNew_Venda.Value := Dm.NewVendaNew_Venda.Value + 1;
      Post;
    finally
    close;
    end;
    end;}
  Dm.Tb_VendaHora_Venda.Value:= Time;
  Dm.Tb_VendaOperador.Value:=Dm.Tb_UsuNome.Value;
  Dm.Tb_VendaDt_Venda.Value := Date;
  Dm.Tb_VendaSub_Tot.Value:=0;
  Dm.Tb_VendaDesconto.Value:=0;
  Dm.Tb_VendaVal_Desc.Value:=0;
  Dm.Tb_VendaAcr.Value:=0;
  Dm.Tb_VendaVal_Acr.Value:=0;
  Dm.Tb_VendaTot_Ger.Value:=0;
  Dm.Tb_VendaVal_Pag.Value:=0;
  Dm.Tb_VendaVal_Debito.Value:=0;
  Dm.Tb_VendaRecebido.Value:=0;
  Dm.Tb_VendaTroco.Value:= 0;
end;

procedure TDm.Tb_ItensVendaAfterDelete(DataSet: TDataSet);
begin
  UpdateTotals;
end;

procedure TDm.Tb_ItensVendaAfterPost(DataSet: TDataSet);
procedure UpdateProd(Cod_Prod: Double; Qty : Double);
  begin
    if (Cod_Prod > 0) and (Qty <> 0) then
    try
      Dm.Tb_Prod.Open;
      Dm.Tb_ItensVenda.Edit;
      Dm.Tb_ItensVendaDt_Venda.Value:=Dm.Tb_VendaDt_Venda.value;
      Dm.Tb_ItensVendaFornecedor.Value:= Dm.Tb_ItensVendaNome_Forne.Value;
      Dm.Tb_ItensVendaTip_pag.Value:= dm.Tb_VendaPag_em.Value;
      Dm.Tb_ItensVendaTipo_venda.Value:= Dm.Tb_VendaTip_Venda.AsString;
      Dm.Tb_ItensVendaOperadora.Value:= Dm.Tb_VendaOperadora.Value;
      Dm.Tb_ItensVendaHora_ini.Value:= Dm.Tb_VendaHora_venda.Value;
      Dm.Tb_ItensVendaVendedor.Value:= Frm_Venda.Funcionario.text;
      Dm.Tb_ItensVendaEdicao.Value:= Dm.Tb_ItensVendaEdicaos.Value;
      Dm.Tb_ItensVendaDescricao.Value:= Dm.Tb_ItensVendaNome_Prod.Value;
      Dm.Tb_ItensVendaVal_prod.Value:= Dm.Tb_ItensVendaValor_unitario.Value;
      Dm.Tb_ItensVendaPercent_Desc.Value:= Dm.Tb_ItensVendaPercent_Desc.Value;
      Dm.Tb_ItensVendaEdicao.Value:= Dm.Tb_VendaESpecificacao.Value;
      Dm.Tb_ItensVendaVal_Desconto.Value:= Dm.Tb_ItensVendaV_Desc.Value;
      Dm.Tb_ItensVendaTotal.Value:= Dm.Tb_ItensVendaValor_unitario.Value*Dm.Tb_ItensVendaQty.Value - (Dm.Tb_ItensVendaVal_Desconto.Value);
      if not Dm.Tb_Prod.Locate('Cod_Barra', Cod_Prod, []) then
      Abort;
      Dm.Tb_Prod.Edit;
      Dm.Tb_ProdQty_Estoque.Value := Dm.Tb_ProdQty_Estoque.Value - Qty;
      Dm.Tb_Prod.Post
    except
      on E: Exception do
        ShowMessage(Format('Erro ao atualizar tabela de Produtos : %d', [Cod_Prod]));
    end;
  end;
begin
  Inc(FItem);
  UpdateTotals;
  if not ((PrevPart = Dm.Tb_ItensVendaCod_Prod.Value) and (PrevQty = Dm.Tb_ItensVendaQty.Value)) then
  begin
    UpdateProd(PrevPart, - PrevQty);
    UpdateProd(Dm.Tb_ItensVendaCod_Prod.Value, Dm.Tb_ItensVendaQty.Value);
  end;
end;

procedure TDm.Tb_ItensVendaBeforeDelete(DataSet: TDataSet);
procedure UpdateProd(Cod_Prod: Double; Qty : Double);
  begin
    if (Cod_Prod > 0) and (Qty <> 0) then
    try
      if not Dm.Tb_Prod.Locate('Cod_Barra', Cod_Prod, []) then
      Abort;
      Dm.Tb_Prod.Open;
      Dm.Tb_Prod.Edit;
      Dm.Tb_ProdQty_Estoque.Value := Dm.Tb_ProdQty_Estoque.Value + Qty;
      Dm.Tb_Prod.Post;
    except
      on E: Exception do
        ShowMessage(Format('Erro ao atualizar tabela de Produtos : %d', [Cod_Prod]));
    end;
  end;
begin
  Inc(FItem);
  UpdateTotals;
  if not ((PrevPart = Dm.Tb_ItensVendaCod_Prod.Value) and (PrevQtyC = Dm.Tb_ItensVendaQty.Value)) then
  begin
    UpdateProd(PrevPart, + PrevQty);
    UpdateProd(Dm.Tb_ItensVendaCod_Prod.Value, Dm.Tb_ItensVendaQty.Value);
  end;
end;

procedure TDm.Tb_ItensVendaBeforeEdit(DataSet: TDataSet);
begin
  Tb_Venda.Edit;
  PrevPart := Dm.Tb_ItensVendaCod_Prod.Value;
  PrevQty := Dm.Tb_ItensVendaQty.Value;
end;

procedure TDm.Tb_ItensVendaBeforeOpen(DataSet: TDataSet);
begin
Dm.Tb_Prod.open;
end;

procedure TDm.Tb_ItensVendaBeforePost(DataSet: TDataSet);
begin
  Dm.Tb_ItensVendaN_Itens.Value := FItem;
end;

procedure TDm.Tb_ItensVendaNewRecord(DataSet: TDataSet);
begin
  PrevPart := 0;
  PrevQty := 0;
  Dm.Tb_ItensVendaN_Venda.Value := Dm.Tb_VendaN_Venda.Value;
  Dm.Tb_ItensVendaQty.Value:=1;
  Dm.Tb_ItensVendaPercent_Desc.Value:= 0;
end;

procedure TDm.Tb_ItensVendaCalcFields(DataSet: TDataSet);
begin
Dm.Tb_ItensVendaV_Desc.Value:= Dm.Tb_ItensVendaQty.Value * Dm.Tb_ItensVendaValor_Unitario.Value * (Dm.Tb_ItensVendaPercent_Desc.Value / 100);
Dm.Tb_ItensVendaVal_Venda.Value:= Dm.Tb_ItensVendaQty.Value * Dm.Tb_ItensVendaValor_Unitario.Value * (100 - Dm.Tb_ItensVendaPercent_Desc.Value)/100;
Dm.Tb_ItensVendaTot_Comi.Value:= Dm.Tb_ItensVendaVal_Comi.Value * Dm.Tb_ItensVendaQty.Value;
end;

procedure TDm.DeleteItemsVenda;
begin
  DeletingItems := True;
  Dm.Tb_ItensVenda.DisableControls;
  Dm.Tb_CReceber.DisableControls;
  Dm.Tb_BContasReceber.DisableControls;
 try
    Dm.Tb_ItensVenda.First;
    Dm.Tb_CReceber.First;
    Dm.Tb_BContasReceber.First;
    Dm.Tb_Prod.Edit;
    while not Dm.Tb_ItensVenda.EOF do Dm.Tb_ItensVenda.Delete;
    While Not Dm.Tb_CReceber.Eof do Dm.Tb_CReceber.Delete;
    While Not Dm.Tb_BContasReceber.Eof do Dm.Tb_BContasReceber.Delete;
  finally
    DeletingItems := False;
    Dm.Tb_ItensVenda.EnableControls;
    Dm.Tb_CReceber.EnableControls;
    Dm.Tb_BContasReceber.EnableControls;
  end;
end;

procedure TDm.EnsureVendaEdit(DataSet: TDataSet);
begin
Dm.Tb_Venda.Edit;
end;

procedure TDm.UpdateTotals;
var
  TempComi: Extended;
  TempTotal: Extended;
  PrevRecord: TBookmark;
begin
  if DeletingItems then
  Exit;
  PrevRecord := Dm.Tb_ItensVenda.GetBookmark;
  try
    Dm.Tb_ItensVenda.DisableControls;
    Dm.Tb_ItensVenda.First;
    TempComi :=0;
    TempTotal := 0;
    while not Dm.Tb_ItensVenda.EOF do
    begin
      TempComi :=  TempComi + Dm.Tb_ItensVendaTot_Comi.Value;
      TempTotal := TempTotal + Dm.Tb_ItensVendaVal_Venda.Value;
      Dm.Tb_ItensVenda.Next;
    end;
    Dm.Tb_VendaComi_Vend.Value:= Tempcomi;
    Dm.Tb_VendaSub_Tot.Value := TempTotal;
  finally
     Dm.Tb_ItensVenda.EnableControls;
     if PrevRecord <> nil then
     begin
       Dm.Tb_ItensVenda.GotoBookmark(PrevRecord);
       Dm.Tb_ItensVenda.FreeBookmark(PrevRecord);
     end;
  end;
end;

procedure TDm.Tb_DevolucaoAfterPost(DataSet: TDataSet);
begin
if Dm.Tb_ItensDevolucao.Locate('N_Devolu', Dm.Tb_ItensDevolucaoN_Devolu.Value, []) Then
  begin
    Dm.Tb_ItensDevolucao.Edit;
    Dm.Tb_ItensDEvolucao.Post;
end;
 end;

procedure TDm.Tb_DevolucaoBeforeDelete(DataSet: TDataSet);
begin
if not Confirm('Excluir venda e todos os seus respectivos'#13'itens e parcelamentos?') then
    Abort
  else
    DeleteItemsDevolu;

end;

procedure TDm.Tb_DevolucaoBeforeEdit(DataSet: TDataSet);
begin
  LastItensDevolu.Close;
  LastItensDevolu.Open;
  with LastItensDevolu.Fields[0] do
    if IsNull then FItemD := 1
    else
    FItemD := AsInteger + 1;
end;

procedure TDm.Tb_DevolucaoBeforeInsert(DataSet: TDataSet);
begin
  if Tb_Devolucao.State in dsEditModes then
  begin
    if Confirm('Uma devoluo de mercadoria est sendo processada. Deseja Grava-la e abrir outra DEvoluo de mercadoria?') then
      Tb_Devolucao.Post
    else
      Abort;
  end;
  FItemD := 1;
end;

procedure TDm.Tb_DevolucaoBeforeOpen(DataSet: TDataSet);
begin
Dm.Tb_ItensDevolucao.Open;
end;

procedure TDm.Tb_DevolucaoNewRecord(DataSet: TDataSet);
begin
 with NewVenda do
  begin
    Open;
    try
      Edit;
      Dm.Tb_DevolucaoN_Devolu.Value := NewDevoluNew_Compra.Value;
      NewDevoluNew_Compra.Value := Dm.NewDevoluNew_Compra.Value + 1;
      Post;
    finally
    close;
    end;
    end;
  Dm.Tb_DevolucaoUsuario.Value:=Dm.Tb_UsuNome.Value;
  Dm.Tb_DevolucaoTot_Devolu.Value:=0;
  Dm.Tb_DevolucaoDesconto.Value:=0;
  Dm.Tb_DevolucaoVal_Desc.Value:=0;
  Dm.Tb_DevolucaoAcr.Value:=0;
  Dm.Tb_DevolucaoVal_Acr.Value:=0;
  Dm.Tb_DevolucaoTot_Ger.Value:=0;
  Dm.Tb_DevolucaoVal_Pag.Value:=0;
  Dm.Tb_DevolucaoDebito.Value:=0;
  end;

procedure TDm.Tb_ItensDevolucaoAfterDelete(DataSet: TDataSet);
begin
  UpdateTotalsDevolu;
end;

procedure TDm.Tb_ItensDevolucaoAfterPost(DataSet: TDataSet);
procedure UpdateProd(Cod_Prod: Double; Qty : Double);
  begin
    if (Cod_Prod > 0) and (Qty <> 0) then
    try
      if not Dm.Tb_Prod.Locate('Cod_Barra', Cod_Prod, []) then
      Abort;
      Dm.Tb_ItensDevolucao.Edit;
      Dm.Tb_ItensDevolucaoDt_Devolu.Value:= Dm.Tb_DevolucaoDt_Devolu.value;
      Dm.Tb_ItensDevolucaoFornecedor.Value:=  Dm.Tb_ItensDevolucaoNome_Forne.Value;
      Dm.Tb_ItensDevolucaoEdicao.Value:= Dm.Tb_ItensDevolucaoEdicaos.Value;
      Dm.Tb_ItensDevolucaoDescricao.Value:= Dm.Tb_ItensDevolucaonome_Prod.Value;
      Dm.Tb_ItensDevolucaoVal_prod.Value:= Dm.Tb_ItensDevolucaoVal_Unit.Value;
      Dm.Tb_ItensDevolucaoQty.Value:= Dm.Tb_ItensDevolucaoQty.Value;
      Dm.Tb_Prod.Edit;
      Dm.Tb_ProdQty_Estoque.Value := Dm.Tb_ProdQty_Estoque.Value - Qty;
      Dm.Tb_ProdQuanho_Real.Value:= Dm.Tb_ProdUltimo_Valor.Value * Dm.Tb_ProdQty_Estoque.Value;
      Dm.Tb_ProdTotal_estoque.Value:=Dm.Tb_ProdVal_Venda.Value * Dm.Tb_ProdQty_Estoque.Value;
      Dm.Tb_Prod.Post;
    except
      on E: Exception do
        ShowMessage(Format('Erro ao atualizar tabela de Produtos : %d', [Cod_Prod]));
    end;
  end;
begin
  Inc(FItemD);
  UpdateTotalsDevolu;
  if not ((PrevPartD = Dm.Tb_ItensDevolucaoCod_Prod.Value) and (PrevQtyD = Dm.Tb_ItensDevolucaoQty.Value)) then
  begin
    UpdateProd(PrevPartD, - PrevQtyD);
    UpdateProd(Dm.Tb_ItensDevolucaoCod_Prod.Value, Dm.Tb_ItensDevolucaoQty.Value);
  end;
end;

procedure TDm.Tb_ItensDevolucaoBeforeDelete(DataSet: TDataSet);
procedure UpdateProd(Cod_Prod: Double; Qty : Double);
  begin
    if (Cod_Prod > 0) and (Qty <> 0) then
    try
      if not Dm.Tb_Prod.Locate('Cod_Barra', Cod_Prod, []) then
      Abort;
      Dm.Tb_Prod.Edit;
      Dm.Tb_ProdQty_Estoque.Value := Dm.Tb_ProdQty_Estoque.Value - Qty;
      Dm.Tb_ProdQuanho_Real.Value:= Dm.Tb_ProdUltimo_Valor.Value * Dm.Tb_ProdQty_Estoque.Value;
      Dm.Tb_ProdTotal_estoque.Value:=Dm.Tb_ProdVal_Venda.Value * Dm.Tb_ProdQty_Estoque.Value;
      Dm.Tb_Prod.Post;
    except
      on E: Exception do
        ShowMessage(Format('Erro ao atualizar tabela de Produtos : %d', [Cod_Prod]));
    end;
  end;
begin
  Inc(FItemD);
  UpdateTotalsDevolu;
  if not ((PrevPartD = Dm.Tb_ItensDevolucaoCod_Prod.Value) and (PrevQtyD = Dm.Tb_ItensDevolucaoQty.Value)) then
  begin
    UpdateProd(PrevPartD, - PrevQtyD);
    UpdateProd(Dm.Tb_ItensDevolucaoCod_Prod.Value, Dm.Tb_ItensDevolucaoQty.Value);
  end;
end;

procedure TDm.Tb_ItensDevolucaoBeforeEdit(DataSet: TDataSet);
begin
  Tb_Devolucao.Edit;
  PrevPartD := Dm.Tb_ItensDevolucaoCod_Prod.Value;
  PrevQtyD := Dm.Tb_ItensDevolucaoQty.Value;
end;

procedure TDm.Tb_ItensDevolucaoBeforePost(DataSet: TDataSet);
begin
  Dm.Tb_ItensDevolucaoN_Itens.Value := FItemD;
end;

procedure TDm.Tb_ItensDevolucaoNewRecord(DataSet: TDataSet);
begin
  PrevPartD := 0;
  PrevQtyD := 0;
  Dm.Tb_ItensDevolucaoN_Devolu.Value := Dm.Tb_DevolucaoN_Devolu.Value;
end;

procedure TDm.Tb_ItensDevolucaoCalcFields(DataSet: TDataSet);
begin
Dm.Tb_ItensDevolucaoVal_Devolu.Value:= Dm.Tb_ItensDevolucaoVal_Unit.Value*Dm.Tb_ItensDevolucaoQty.Value;
end;

procedure TDm.DeleteItemsDevolu;
begin
  DeletingItemsD := True;
  Dm.Tb_ItensDevolucao.DisableControls;
 try
    Dm.Tb_ItensDevolucao.First;
    Dm.Tb_Prod.Edit;
    while not Dm.Tb_ItensDevolucao.EOF do Dm.Tb_ItensDevolucao.Delete;
//  While Not Dm.Tb_Movimento.Eof do Dm.Tb_Movimento.Delete;    
   finally
    DeletingItemsD := False;
    Dm.Tb_ItensDevolucao.EnableControls;
  end;
end;

procedure TDm.EnsureDevolucaoEdit(DataSet: TDataSet);
begin
  Dm.Tb_Devolucao.Edit;
end;

procedure TDm.UpdateTotalsDevolu;
var
  TempTotal: Extended;
  PrevRecord: TBookmark;
begin
  if DeletingItemsD then
  Exit;
  PrevRecord := Dm.Tb_ItensDevolucao.GetBookmark;
  try
    Dm.Tb_ItensDevolucao.DisableControls;
    Dm.Tb_ItensDevolucao.First;
    TempTotal := 0;
    while not Dm.Tb_ItensDevolucao.EOF do
    begin
      TempTotal := TempTotal + Dm.Tb_ItensDevolucaoVal_Devolu.Value;
      Dm.Tb_ItensDevolucao.Next;
    end;
    Dm.Tb_DevolucaoTot_Devolu.Value := TempTotal;
  finally
     Dm.Tb_ItensDevolucao.EnableControls;
     if PrevRecord <> nil then
     begin
       Dm.Tb_ItensDevolucao.GotoBookmark(PrevRecord);
       Dm.Tb_ItensDevolucao.FreeBookmark(PrevRecord);
     end;
  end;
end;

procedure TDm.Tb_ItensVendaQtyValidate(Sender: TField);
begin
  if Dm.Tb_ItensVendaQty.Value > Dm.Tb_ProdQty_Estoque.Value + 1 then
    raise Exception.Create('No existe quatidade suficente em estoque para efetuar esta venda '#13' Por favor diminua a quantidade a ser devolvida');
end;

procedure TDm.Tb_ItensVendaCod_ProdValidate(Sender: TField);
begin
  if not Dm.Tb_Prod.Locate('Cod_Barra', Dm.Tb_ItensVendaCod_Prod.Value, []) then
   raise Exception.Create('Voc precisa especificar um codigo vlido para o produto');
end;

procedure TDm.Tb_ItensCompraQtyValidate(Sender: TField);
begin
  if Dm.Tb_ItensCompraQty.Value <= 0 then
    raise Exception.Create('Quatidade para compra  de produto no pode '#13' ser inferior ou igual a zero');
end;

procedure TDm.Tb_VendaDt_VendaValidate(Sender: TField);
begin
  if Dm.Tb_VendaDt_Venda.Value > Now then
  raise Exception.Create('No e possivel efetuar venda para uma data futura');
end;

procedure TDm.Tb_ItensDevolucaoQtyValidate(Sender: TField);
begin
  if Dm.Tb_ItensDevolucaoQty.Value > Dm.Tb_ProdQty_Estoque.Value + 1 then
    raise Exception.Create('No existe quatidade suficente em estoque para efetuar esta devoluo '#13' Por favor diminua a quantidade a ser devolvida');
end;

procedure TDm.Tb_ItensDevolucaoCod_prodValidate(Sender: TField);
begin
  if not Dm.Tb_Prod.Locate('Cod_Barra', Dm.Tb_ItensDevolucaoCod_Prod.Value, []) then
   raise Exception.Create('Voc precisa especificar um codigo vlido para o produto');
end;

procedure TDm.Tb_CDiversasNewRecord(DataSet: TDataSet);
begin
Dm.Tb_CDiversasDat_Cad.Value:=Date;
end;

procedure TDm.Tb_VendaBeforeClose(DataSet: TDataSet);
begin
 Dm.Tb_ItensVenda.Close;
end;

procedure TDm.Tb_VendaBeforeCancel(DataSet: TDataSet);
begin
if (Dm.Tb_Venda.State = dsInsert) and not (Dm.Tb_ItensVenda.BOF and Dm.Tb_ItensVenda.EOF and Dm.Tb_CReceber.EOF) then
    if not Confirm('Cancelar inclusso de Venda e seus respectivos'#13'itens e parcelamentos?') then
      Abort;
end;

end.


