unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, DBGrids, Db, DBTables, ExcelExport,shellapi, ComCtrls,
  Buttons, Mask, DBCtrls;

type
  TForm1 = class(TForm)
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Exportar: TButton;
    ExcelExport1: TExcelExport;
    Button2: TButton;
    Query1: TQuery;
    Query1N_Venda: TFloatField;
    Query1N_Nota: TFloatField;
    Query1Operador: TStringField;
    Query1Dt_Venda: TDateField;
    Query1Tip_venda: TStringField;
    Query1Cliente: TStringField;
    Query1Vendedor: TStringField;
    Query1Pag_em: TStringField;
    Query1Operadora: TStringField;
    Query1ESpecificacao: TStringField;
    Query1Cod_Pag: TStringField;
    Query1Descri_Pag: TStringField;
    Query1N_Pacelas: TStringField;
    Query1Sub_Tot: TCurrencyField;
    Query1Comi_Vend: TCurrencyField;
    Query1Desconto: TFloatField;
    Query1Val_Desc: TCurrencyField;
    Query1Acr: TFloatField;
    Query1Val_Acr: TCurrencyField;
    Query1Tot_Ger: TCurrencyField;
    Query1Val_Pag: TCurrencyField;
    Query1Val_Debito: TCurrencyField;
    Query1Recebido: TCurrencyField;
    Query1Troco: TCurrencyField;
    Query1Situacao: TStringField;
    Query1Preco_Custo: TCurrencyField;
    Query1Tip_Mov: TStringField;
    Query1Descr_Mov: TStringField;
    Query1Entrega: TStringField;
    Query1Prev_entrega: TDateField;
    Query1Dt_envio: TDateField;
    Query1Dt_entrega: TDateField;
    Query1Dt_Devolucao: TDateField;
    Query1D_Atraso: TFloatField;
    Query1Hora_venda: TTimeField;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Data1: TDateTimePicker;
    Data2: TDateTimePicker;
    GroupBox3: TGroupBox;
    Vendedor: TEdit;
    Campo: TComboBox;
    Label3: TLabel;
    GroupBox4: TGroupBox;
    LQN: TCheckBox;
    NP: TCheckBox;
    Ativar: TCheckBox;
    Consulta: TBitBtn;
    TPVD: TLabel;
    Label5: TEdit;
    Query1TotalBu: TCurrencyField;
    ToTalBu: TDBEdit;
    Vendedores: TDBGrid;
    UpdateSQL1: TUpdateSQL;
    Query2: TQuery;
    Query2Cod_Funci: TStringField;
    Query2Nome: TStringField;
    Query2End: TStringField;
    Query2Bairro: TStringField;
    Query2Cep: TStringField;
    Query2Cidade: TStringField;
    Query2Uf: TStringField;
    Query2Tel: TStringField;
    Query2Tel_contato: TStringField;
    Query2Cel: TStringField;
    Query2Rg: TStringField;
    Query2Cpf: TStringField;
    Query2Ativo: TStringField;
    Query2Dt_Cad: TDateField;
    Query2Dt_NIver: TDateField;
    Query2Email: TStringField;
    Ds_Query2: TDataSource;
    VendedorSel: TDBEdit;
    procedure ExportarClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ConsultaClick(Sender: TObject);
    procedure AtivarClick(Sender: TObject);
    procedure LQNClick(Sender: TObject);
    procedure NPClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure VendedorChange(Sender: TObject);
    procedure VendedorExit(Sender: TObject);
    procedure VendedorKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure VendedoresCellClick(Column: TColumn);
    procedure VendedoresKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.ExportarClick(Sender: TObject);
begin
  ExcelExport1.Dataset:=Query1;
  ExcelExport1.ExportDataset;
  ExcelExport1.Disconnect;

  Query1.Active:= False;

end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  ExcelExport1.WorksheetName := 'MyDataSet';
  ExcelExport1.Dataset:=Query1;
  ExcelExport1.StyleColumnWidth:=cwOwnerWidth;
  ExcelExport1.ColumnWidth := 20;
//  ExcelExport1.FontTitles := LabelTitle.Font;
  ExcelExport1.OrientationTitles := 45;
//  ExcelExport1.FontData := LabelData.Font;
 // ExcelExport1.ExcelVisible:=False;
  ExcelExport1.ExportDataset;
//  ExcelExport1.SaveAs('c:\test.xls',ffXLS);
  ExcelExport1.Disconnect;
  Query1.Active:= False;

end;

procedure TForm1.ConsultaClick(Sender: TObject);
Var
AnoI, MesI, DiaI, AnoF, MesF, DiaF : Word;
    Passo : Integer;
    DataI, DataF : String;
    I : Integer;
    Total: Extended;
    TotalProd: Extended;
begin
// Localizar todas de um Vendedor especifico
If ((LQN.Checked = True) and (Data1.Enabled = False))  Then
       begin
        Query1.SQL.Text:= ' Select * From Venda Where Tot_Ger > 0 '
                + 'and ' + Campo.Text + ' ' +  ' Like ' + Chr(39) +  Vendedor.Text  + Chr(39);
        Query1.Active:=True;
        Exportar.SetFocus;
        end;
//De Todos os Vendedores
If ((NP.Checked = True) and (Data1.Enabled = False))  Then
       Begin
        Query1.SQL.Text:='Select * From Venda Where Tot_Ger > 0';
        Query1.Active:=True;
        Exportar.SetFocus;
       end;

If ((Data1.Enabled = true) and (Data2.Enabled = True)) Then
begin
If Data1.Enabled = true then
if Data2.Enabled = True Then
Begin
If Data2.Date < Data1.Date Then
begin
  ShowMessage('Intervalo de datas invlido, data inicial maior que a data final!');
  Data2.Date := Data1.Date;
end
Else
//Localiza de Todos os Vendedores

        DecodeDate(Data1.Date,AnoI,MesI,DiaI);
        DecodeDate(Data2.Date,AnoF, MesF, DiaF);

        DataI := DateToStr(Data1.Date);
        DataF := DateToStr(Data2.Date);

         If LQN.Checked = True  Then
begin
        Query1.Close;
        Query1.SQL.Clear;
        Query1.SQL.Text := 'SELECT * FROM Venda WHERE dt_Venda >=:pInicial and dt_Venda<=:pFinal '
        + ' and ' +  Campo.Text + ' ' +  ' Like ' + Chr(39) +  Vendedor.Text  + Chr(39);
        Query1.ParamByName('pInicial').AsDateTime := StrToDate(DataI);
        Query1.ParamByName('pFinal').AsDateTime :=   StrToDate(DataF);
        Query1.Active:=True;
        Exportar.SetFocus;
        end;

        if NP.Checked = True  Then
        begin
        Query1.Close;
        Query1.SQL.Clear;
        Query1.SQL.Text:='Select * From Venda WHERE dt_Venda >=:pInicial and dt_Venda<=:pFinal';
        Query1.ParamByName('pInicial').AsDateTime := StrToDate(DataI);
        Query1.ParamByName('pFinal').AsDateTime :=   StrToDate(DataF);
        Query1.Active:=True;
        Exportar.SetFocus;
        end;
         end;
          end;

        Total := 0;
        for I := 1 to Query1.RecordCount Do
        Begin
                DataSource1.DataSet.Open;
                DataSource1.DataSet.Edit;
                Total := (Query1Tot_Ger.Value + Total);
                Query1.Next;
        End;
                DataSource1.DataSet.Open;
                DataSource1.DataSet.Edit;
                Query1TotalBu.Value := Total;
                Label5.Text := TotalBu.Text;
end;
 procedure TForm1.AtivarClick(Sender: TObject);
begin
If  Ativar.Checked = True Then
Begin
Vendedores.Visible:=False;
Data1.Enabled := True;
Data2.Enabled := True;
End;
If  Ativar.Checked = False Then
Begin
Vendedores.Visible:=False;
Data1.Enabled := False;
Data2.Enabled := False;
end;
end;

procedure TForm1.LQNClick(Sender: TObject);
begin
If LQN.Checked = True Then
Begin
NP.Checked:= False;
Vendedores.Visible:=False;
Vendedor.SetFocus;
end;
 end;

procedure TForm1.NPClick(Sender: TObject);
begin
If NP.Checked = True Then
begin
LQN.Checked := False;
Vendedor.Text:='';
Vendedores.Visible:=False;
Consulta.SetFocus;
end;
end;

procedure TForm1.FormShow(Sender: TObject);
var
dia,mes,ano,dia1,mes1,ano1: string;
date1,date2: Tdatetime;
begin
dia:= formatdatetime('1',date);
mes:= formatdatetime('mm',date);
ano:= formatdatetime('yyyy',date);
dia1:= formatdatetime('dd',date);
mes1:= formatdatetime('mm',date);
ano1:= formatdatetime('yyyy',date);
date1:= strtodate(dia+'/'+mes+'/'+ano);
date2:= strtodate(dia1+'/'+mes1+'/'+ano1);
data1.Date:= date1;
data2.Date:= date2;
Consulta.SetFocus;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
Data1.Enabled:= False;
Data2.Enabled:= False;
Consulta.SetFocus;
LQN.Checked:=False;
NP.Checked:=False;
end;

procedure TForm1.VendedorChange(Sender: TObject);
begin
Vendedores.Visible:=True;

Query2.SQL.Text := 'Select * from Funcinario Where Nome Like '
+ Chr(39) + '%' + Vendedor.Text + '%' + Chr(39);

Query2.Active := True;
end;

procedure TForm1.VendedorExit(Sender: TObject);
begin
if Vendedor.Text = '' then
begin
Vendedores.Visible:= True;
Consulta.SetFocus;
end
else
Vendedores.Visible:=True;
Vendedores.SetFocus;
end;

procedure TForm1.VendedorKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if KEY = vk_Return Then
begin
Vendedor.Text := VendedorSel.Text;
Vendedores.Visible := False;
Consulta.SetFocus;
end;
if KEY = vk_Escape then
begin
Close;
end
end;

procedure TForm1.VendedoresCellClick(Column: TColumn);
begin
Vendedor.Text := VendedorSel.Text;
Vendedores.Visible := False;
Consulta.SetFocus;
end;

procedure TForm1.VendedoresKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if KEY = vk_Return Then
begin
Vendedor.Text := VendedorSel.Text;
Vendedores.Visible := False;
Consulta.SetFocus;
end;
if KEY = vk_Escape then
begin
Close;
end;
end;

end.
